# compiler and flags to use
CC = gcc
CFLAGS = -Wall 

# perl interpreter with path if necessary
PERL = perl

# full path to QLA directory
QLADIR = $(HOME)/scidac/qla

# uncomment to make MPI version of library
#USE_MPI = yes
# full path to MPI header
MPIINC = /usr/include/mpi

# uncomment to make QMP version of library
#USE_QMP = yes
# full path to QMP directory
QMPDIR = 

# other directories and filenames that should probably be left as they are
GENDIR = generate
SRCDIR = src
INCDIR = include
LIBDIR = lib
LOGFILE = make.log
TARFILE = qdp-1.0.tar.gz
